//このページをメインにゲームなどのコンテンツが作れます。

import cyan3d.*;
import models.*;

class Main
{
	var _container:MovieClip;
	var _camera:Camera3D;
	var _obj:Model3D;
	var _mouse:Boolean = false;
	
	public static function main(swfRoot:MovieClip):Void 
	{
		var app:Main = new Main();
	}
	
	public function Main() 
	{
		var _main = this;
		_container = _root.createEmptyMovieClip(
			"_container", _root.getNextHighestDepth()); 
		_container._x = Stage.width/2;
		_container._y = Stage.height / 2;
		//毎フレーム呼び出し
		_root.onEnterFrame = function() { _main.rendering(); }
		//マウスが押されたら呼び出し
		_root.onMouseDown = function() { _main.onDown(); }
		//マウスが離されたら呼び出し
		_root.onMouseUp = function() { _main.onUp(); }
		//キーが押されたら呼び出し
		_root.onKeyDown = function() { _main.onDown(); }
		//キーが離されたら呼び出し
		_root.onKeyUp = function() { _main.onUp(); }
		Key.addListener(_root);
		//オブジェクト読み込み
		_obj = new Usatama();
		//カメラ
		_camera = new Camera3D();
	}

	public function onDown()
	{
		_mouse = true;
	}

	public function onUp()
	{
		_mouse = false;
	}
	
	public function rendering()
	{
		_camera._position = new Vector3D(-100, -200, -400);
		_camera._lookAt = new Vector3D(0, -130, 0);

		//MovieClipクリア
		_container.clear();

		//オブジェクト1
		var radian:Number = _obj._rotate._y * Matrix3D.toRadian;
		if ( _mouse )
		{
			_obj._trans._x -= Math.sin(radian)*10;
			_obj._trans._z -= Math.cos(radian)*10;
		}
		else
		{
			_obj._rotate._y += 10;
			if ( _obj._rotate._y >= 360 )
			{
				_obj._rotate._y -= 360;
			}
		}
		_obj.transform(_camera);
		_obj.draw(_container);
	}
}
