﻿class cyan3d.Vector3D
{
	var _x:Number = 0;
	var _y:Number = 0;
	var _z:Number = 0;
   
	public function Vector3D(x:Number, y:Number, z:Number)
    {
        _x = x;
        _y = y;
        _z = z;
    }

	public function length():Number
    {
		return (Math.sqrt(_x*_x + _y*_y + _z*_z));
    }
	
	public function normalize()
	{
		var l:Number = this.length();
		if ( l == 0 )
		{
			_x = 0;
			_y = 0;
			_z = 1;
		}
		else
		{
			_x /= l;
			_y /= l;
			_z /= l;
		}
	}

	public function dotProduct(v:Vector3D):Number
    {
 		return (v._x * _x + v._y * _y + v._z * _z);
    }

	public function crossProduct(v:Vector3D):Vector3D
	{
		var x:Number = (_y*v._z) - (v._y*_z);
		var y:Number = (v._x*_z) - (_x*v._z);
		var z:Number = (_x*v._y) - (v._x*_y);
		return (new Vector3D(x, y, z));
	}

	public function toString():String
    {
		return(new String("(" + _x + "," + _y + "," + _z + ")"));
    }
}