import cyan3d.*;

class models.Cube extends Model3D
{
	public function Cube(size:Number)
    {
		//親クラスのコンストラクタ呼び出し
		super();
		//材質
		_material = new Array();
		addM(0xff,0,0);
		addM(0,0xff,0);
		addM(0,0,0xff);
		//ワールド座標頂点
		_world = new Array();
		addV(-size, -size, -size);
		addV(-size,  size, -size);
		addV( size,  size, -size);
		addV( size, -size, -size);
		addV(-size, -size,  size);
		addV(-size,  size,  size);
		addV( size,  size,  size);
		addV( size, -size,  size);
		//3D面
		_face = new Array();
		addF(new Array(2, 1, 0),0);
		addF(new Array(0, 3, 2),0);
		addF(new Array(4, 5, 6, 7),0);
		addF(new Array(0, 1, 5, 4),2);
		addF(new Array(1, 2, 6, 5),1);
		addF(new Array(2, 3, 7, 6),2);
		addF(new Array(3, 0, 4, 7), 1);
		
		init();
    }
}
